package com.cleanmaster.service.watcher;
import  com.cleanmaster.service.watcher.RunningTaskModel;

interface IAppLaunchNotify {
	/*
	 * APP启动回调，这个函数必须立即返回，处理逻辑请异步处理
	 * 
	 * param：pkgName	当前启动的包名
	 * 		  time		当前系统时间
	 *        activityName 当前activityName
	 * */
	void OnAppLaunch(String pkgName, long time,String activityName);
	
	/*
	* APP切换回调
	* param：currentTopPkgName	当前正在运行的包名
	*		 currentTopPkgActivityCount	top包里面正在运行的activity个数，
										系统枚举 top包方法存在问题，获得的top包不一定是最新的，
										可能出现拿到的top包其实是上一次运行的app，例如天天酷跑
										
										如果 currentTopPkgActivityCount = 0，那么可以确认app肯定退出了
	*        previousPkgName	之前运行的包名
	*/
	void OnAppUsageChange(String currentTopPkgName,  int currentTopPkgActivityCount, String previousPkgName);
	void OnAppUsageChangeEx(in RunningTaskModel currentTask, in RunningTaskModel preTask);
}
